local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert
local Database = BaikCore.Database
local Debug = BaikCore.Debug
local Log = BaikCore.Log

-- Add Module to BaikCore
local Option = BaikCore:NewModule("Option")
BaikCore.Option = Option

-- Constants
local options = {
    name = "Baik",
    handler = BaikCore,
    type = "group",
    args = {
        general = {
            name = "General",
            type = "group",
            childGroups = "tab",
            args = {
            }
        },
    }
}

Option.NAME = "general"

-- Public API
function Option:AddCategory(category, opts)
    Assert:String(category)
    if not options.args[category] then
        options.args[category] = opts
    end
end

function Option:AddOption(category, name, opt)
    Assert:String(category)
    Assert:NotNull(options.args[category])
    Assert:NotNull(options.args[category].args)

    options.args[category].args[name] = opt
end

-- Ace3 Callbacks
function Option:OnInitialize()
    options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(Database:Raw())
    options.args.profiles.order = -1
end

function Option:OnEnable()
    LibStub("AceConfig-3.0"):RegisterOptionsTable(BaikCore.NAME, options)
    LibStub("AceConfigDialog-3.0"):AddToBlizOptions(BaikCore.NAME, BaikCore.NAME)
end

function Option:OnDisable()
end
